diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/indexes/utils.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/indexes/utils.py
new file mode 100644
index 000000000..edd80df26
--- /dev/null
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/indexes/utils.py
@@ -0,0 +1,280 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2019, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+""" Implements Utility class for Indexes. """
+
+from flask import render_template
+from flask_babelex import gettext as _
+from pgadmin.utils.ajax import internal_server_error
+from pgadmin.utils.exception import ObjectGone
+from functools import wraps
+
+
+def get_template_path(f):
+    """
+    This function will behave as a decorator which will prepare
+    the template path based on database server version.
+    """
+
+    @wraps(f)
+    def wrap(*args, **kwargs):
+        # Here args[0] will hold the connection object
+        conn_obj = args[0]
+        template_path = ''
+        if 'template_path' not in kwargs:
+            template_path = \
+                'indexes/sql/#{0}#'.format(conn_obj.manager.version)
+        else:
+            template_path = kwargs['template_path']
+
+        return f(*args, **kwargs, template_path=template_path)
+    return wrap
+
+
+@get_template_path
+def get_parent(conn, tid, template_path=None):
+    """
+    This function will return the parent of the given table.
+    :param conn: Connection Object
+    :param tid: Table oid
+    :param template_path: Optional template path
+    :return:
+    """
+
+    SQL = render_template("/".join([template_path,
+                                    'get_parent.sql']), tid=tid)
+    status, rset = conn.execute_2darray(SQL)
+    if not status:
+        raise Exception(rset)
+
+    schema = ''
+    table = ''
+    if 'rows' in rset and len(rset['rows']) > 0:
+        schema = rset['rows'][0]['schema']
+        table = rset['rows'][0]['table']
+
+    return schema, table
+
+
+@get_template_path
+def get_column_details(conn, idx, data, mode='properties', template_path=None):
+    """
+    This functional will fetch list of column for index.
+
+    :param conn: Connection Object
+    :param idx: Index ID
+    :param data: Data
+    :param mode: 'create' or 'properties'
+    :param template_path: Optional template path
+    :return:
+    """
+
+    SQL = render_template(
+        "/".join([template_path, 'column_details.sql']), idx=idx
+    )
+    status, rset = conn.execute_2darray(SQL)
+    if not status:
+        return internal_server_error(errormsg=rset)
+
+    # 'attdef' comes with quotes from query so we need to strip them
+    # 'options' we need true/false to render switch ASC(false)/DESC(true)
+    columns = []
+    cols = []
+    for row in rset['rows']:
+        # We need all data as collection for ColumnsModel
+        # we will not strip down colname when using in SQL to display
+        cols_data = {
+            'colname': row['attdef'] if mode == 'create' else
+            row['attdef'].strip('"'),
+            'collspcname': row['collnspname'],
+            'op_class': row['opcname'],
+        }
+
+        # ASC/DESC and NULLS works only with btree indexes
+        if 'amname' in data and data['amname'] == 'btree':
+            cols_data['sort_order'] = False
+            if row['options'][0] == 'DESC':
+                cols_data['sort_order'] = True
+
+            cols_data['nulls'] = False
+            if row['options'][1].split(" ")[1] == 'FIRST':
+                cols_data['nulls'] = True
+
+        columns.append(cols_data)
+
+        # We need same data as string to display in properties window
+        # If multiple column then separate it by colon
+        cols_str = row['attdef']
+        if row['collnspname']:
+            cols_str += ' COLLATE ' + row['collnspname']
+        if row['opcname']:
+            cols_str += ' ' + row['opcname']
+
+        # ASC/DESC and NULLS works only with btree indexes
+        if 'amname' in data and data['amname'] == 'btree':
+            # Append sort order
+            cols_str += ' ' + row['options'][0]
+            # Append nulls value
+            cols_str += ' ' + row['options'][1]
+
+        cols.append(cols_str)
+
+    # Push as collection
+    data['columns'] = columns
+    # Push as string
+    data['columns_csv'] = ', '.join(cols)
+
+    return data
+
+
+@get_template_path
+def get_include_details(conn, idx, data, template_path=None):
+    """
+    This functional will fetch list of include details for index
+    supported with Postgres 11+
+
+    :param conn: Connection object
+    :param idx: Index ID
+    :param data: data
+    :param template_path: Optional template path
+    :return:
+    """
+
+    SQL = render_template(
+        "/".join([template_path, 'include_details.sql']), idx=idx
+    )
+    status, rset = conn.execute_2darray(SQL)
+    if not status:
+        return internal_server_error(errormsg=rset)
+
+    # Push as collection
+    data['include'] = [col['colname'] for col in rset['rows']]
+
+    return data
+
+
+@get_template_path
+def get_sql(conn, data, did, tid, idx, datlastsysoid,
+            mode=None, template_path=None):
+    """
+    This function will generate sql from model data.
+
+    :param conn: Connection Object
+    :param data: Data
+    :param did:
+    :param tid: Table ID
+    :param idx: Index ID
+    :param datlastsysoid:
+    :param mode:
+    :param template_path: Optional template path
+    :return:
+    """
+    name = data['name'] if 'name' in data else None
+    if idx is not None:
+        SQL = render_template("/".join([template_path, 'properties.sql']),
+                              did=did, tid=tid, idx=idx,
+                              datlastsysoid=datlastsysoid)
+
+        status, res = conn.execute_dict(SQL)
+        if not status:
+            return internal_server_error(errormsg=res)
+
+        if len(res['rows']) == 0:
+            raise ObjectGone(_('Could not find the index in the table.'))
+
+        old_data = dict(res['rows'][0])
+
+        # If name is not present in data then
+        # we will fetch it from old data, we also need schema & table name
+        if 'name' not in data:
+            name = data['name'] = old_data['name']
+
+        SQL = render_template(
+            "/".join([template_path, 'update.sql']),
+            data=data, o_data=old_data, conn=conn
+        )
+    else:
+        required_args = {
+            'name': 'Name',
+            'columns': 'Columns'
+        }
+        for arg in required_args:
+            err = False
+            if arg == 'columns' and len(data['columns']) < 1:
+                err = True
+
+            if arg not in data:
+                err = True
+                # Check if we have at least one column
+            if err:
+                return _('-- definition incomplete'), name
+
+        # If the request for new object which do not have did
+        SQL = render_template(
+            "/".join([template_path, 'create.sql']),
+            data=data, conn=conn, mode=mode
+        )
+        SQL += "\n"
+        SQL += render_template(
+            "/".join([template_path, 'alter.sql']),
+            data=data, conn=conn
+        )
+
+    return SQL, name
+
+
+@get_template_path
+def get_reverse_engineered_sql(conn, schema, table, did, tid, idx,
+                               datlastsysoid,
+                               template_path=None):
+    """
+    This function will return reverse engineered sql for specified trigger.
+
+    :param conn: Connection Object
+    :param schema: Schema
+    :param table: Table
+    :param tid: Table ID
+    :param idx: Index ID
+    :param datlastsysoid:
+    :param template_path: Optional template path
+    :return:
+    """
+    SQL = render_template("/".join([template_path, 'properties.sql']),
+                          did=did, tid=tid, idx=idx,
+                          datlastsysoid=datlastsysoid)
+
+    status, res = conn.execute_dict(SQL)
+    if not status:
+        raise Exception(res)
+
+    if len(res['rows']) == 0:
+        raise ObjectGone(_('Could not find the index in the table.'))
+
+    data = dict(res['rows'][0])
+    # Adding parent into data dict, will be using it while creating sql
+    data['schema'] = schema
+    data['table'] = table
+
+    # Add column details for current index
+    data = get_column_details(conn, idx, data, 'create')
+
+    # Add Include details of the index
+    if conn.manager.version >= 110000:
+        data = get_include_details(conn, idx, data)
+
+    SQL, name = get_sql(conn, data, did, tid, None, datlastsysoid)
+
+    sql_header = u"-- Index: {0}\n\n-- ".format(data['name'])
+
+    sql_header += render_template("/".join([template_path, 'delete.sql']),
+                                  data=data, conn=conn)
+
+    SQL = sql_header + '\n\n' + SQL
+
+    return SQL
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/tests/test_utils.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/tests/test_utils.py
index f84ec3d14..5ac6f7b25 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/tests/test_utils.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/tests/test_utils.py
@@ -55,15 +55,6 @@ class TestUtils(BaseTestGenerator):
                 subject.table_template_path, 'tables/sql/#gpdb#10#')
             self.assertEqual(
                 subject.data_type_template_path, 'datatype/sql/#gpdb#10#')
-            self.assertEqual(
-                subject.check_constraint_template_path,
-                'check_constraint/sql/#gpdb#10#')
-            self.assertEqual(
-                subject.exclusion_constraint_template_path,
-                'exclusion_constraint/sql/#gpdb#10#')
-            self.assertEqual(
-                subject.foreign_key_template_path,
-                'foreign_key/sql/#gpdb#10#')
             self.assertEqual(
                 subject.index_template_path,
                 'indexes/sql/#gpdb#10#')
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/triggers/__init__.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/triggers/__init__.py
index ecc231725..61b53f993 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/triggers/__init__.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/triggers/__init__.py
@@ -13,6 +13,10 @@ import simplejson as json
 from functools import wraps
 
 import pgadmin.browser.server_groups.servers.databases as database
+import pgadmin.browser.server_groups.servers.databases.schemas.tables.\
+    triggers.utils as trigger_utils
+from pgadmin.browser.server_groups.servers.databases.schemas.utils \
+    import trigger_definition
 from flask import render_template, request, jsonify
 from flask_babelex import gettext
 from pgadmin.browser.collection import CollectionNodeModule
@@ -192,9 +196,6 @@ class TriggerView(PGChildNodeView):
       - This function is used to return modified SQL for the selected
         Trigger node
 
-    * get_sql(data, scid, tid, trid)
-      - This function will generate sql from model data
-
     * sql(gid, sid, did, scid, tid, trid):
       - This function will generate sql to show it in sql pane for the
         selected Trigger node.
@@ -210,13 +211,6 @@ class TriggerView(PGChildNodeView):
     * get_trigger_functions(gid, sid, did, scid, tid, trid):
       - This function will return list of trigger functions available
         via AJAX response
-
-    * _column_details(tid, clist)::
-      - This function will fetch the columns for trigger
-
-    * _trigger_definition(data):
-      - This function will set additional trigger definitions in
-        AJAX response
     """
 
     node_type = blueprint.node_type
@@ -280,28 +274,9 @@ class TriggerView(PGChildNodeView):
             # We need parent's name eg table name and schema name
             # when we create new trigger in update we can fetch it using
             # property sql
-            SQL = render_template("/".join([self.template_path,
-                                            'get_parent.sql']),
-                                  tid=kwargs['tid'])
-            status, rset = self.conn.execute_2darray(SQL)
-            if not status:
-                return internal_server_error(errormsg=rset)
-
-            for row in rset['rows']:
-                self.schema = row['schema']
-                self.table = row['table']
-
-            # Here we are storing trigger definition
-            # We will use it to check trigger type definition
-            self.trigger_definition = {
-                'TRIGGER_TYPE_ROW': (1 << 0),
-                'TRIGGER_TYPE_BEFORE': (1 << 1),
-                'TRIGGER_TYPE_INSERT': (1 << 2),
-                'TRIGGER_TYPE_DELETE': (1 << 3),
-                'TRIGGER_TYPE_UPDATE': (1 << 4),
-                'TRIGGER_TYPE_TRUNCATE': (1 << 5),
-                'TRIGGER_TYPE_INSTEAD': (1 << 6)
-            }
+            schema, table = trigger_utils.get_parent(self.conn, kwargs['tid'])
+            self.schema = schema
+            self.table = table
 
             return f(*args, **kwargs)
 
@@ -458,93 +433,6 @@ class TriggerView(PGChildNodeView):
             status=200
         )
 
-    def _column_details(self, tid, clist):
-        """
-        This functional will fetch list of column for trigger
-
-        Args:
-            tid: Table OID
-            clist: List of columns
-
-        Returns:
-            Updated properties data with column
-        """
-
-        SQL = render_template("/".join([self.template_path,
-                                        'get_columns.sql']),
-                              tid=tid, clist=clist)
-        status, rset = self.conn.execute_2darray(SQL)
-        if not status:
-            return internal_server_error(errormsg=rset)
-        # 'tgattr' contains list of columns from table used in trigger
-        columns = []
-
-        for row in rset['rows']:
-            columns.append(row['name'])
-
-        return columns
-
-    def _trigger_definition(self, data):
-        """
-        This functional will set the trigger definition
-
-        Args:
-            data: Properties data
-
-        Returns:
-            Updated properties data with trigger definition
-        """
-
-        # Fires event definition
-        if data['tgtype'] & self.trigger_definition['TRIGGER_TYPE_BEFORE']:
-            data['fires'] = 'BEFORE'
-        elif data['tgtype'] & self.trigger_definition['TRIGGER_TYPE_INSTEAD']:
-            data['fires'] = 'INSTEAD OF'
-        else:
-            data['fires'] = 'AFTER'
-
-        # Trigger of type definition
-        if data['tgtype'] & self.trigger_definition['TRIGGER_TYPE_ROW']:
-            data['is_row_trigger'] = True
-        else:
-            data['is_row_trigger'] = False
-
-        # Event definition
-        if data['tgtype'] & self.trigger_definition['TRIGGER_TYPE_INSERT']:
-            data['evnt_insert'] = True
-        else:
-            data['evnt_insert'] = False
-
-        if data['tgtype'] & self.trigger_definition['TRIGGER_TYPE_DELETE']:
-            data['evnt_delete'] = True
-        else:
-            data['evnt_delete'] = False
-
-        if data['tgtype'] & self.trigger_definition['TRIGGER_TYPE_UPDATE']:
-            data['evnt_update'] = True
-        else:
-            data['evnt_update'] = False
-
-        if data['tgtype'] & self.trigger_definition['TRIGGER_TYPE_TRUNCATE']:
-            data['evnt_truncate'] = True
-        else:
-            data['evnt_truncate'] = False
-
-        return data
-
-    def _format_args(self, args):
-        """
-        This function will format arguments.
-
-        Args:
-            args: Arguments
-
-        Returns:
-            Formated arguments for function
-        """
-        formatted_args = ["'{0}'".format(arg) for arg in args]
-        return ', '.join(formatted_args)
-
     @check_precondition
     def properties(self, gid, sid, did, scid, tid, trid):
         """
@@ -579,18 +467,10 @@ class TriggerView(PGChildNodeView):
 
         # Making copy of output for future use
         data = dict(res['rows'][0])
-        data = self.get_trigger_function_schema(data)
-
-        if len(data['custom_tgargs']) > 1:
-            # We know that trigger has more than 1 argument, let's join them
-            # and convert it to string
-            data['tgargs'] = self._format_args(data['custom_tgargs'])
+        data = trigger_utils.get_trigger_function_and_columns(
+            self.conn, data, tid, self.blueprint.show_system_objects)
 
-        if len(data['tgattr']) >= 1:
-            columns = ', '.join(data['tgattr'].split(' '))
-            data['columns'] = self._column_details(tid, columns)
-
-        data = self._trigger_definition(data)
+        data = trigger_definition(data)
 
         return ajax_response(
             response=data,
@@ -763,7 +643,10 @@ class TriggerView(PGChildNodeView):
             data['schema'] = self.schema
             data['table'] = self.table
 
-            SQL, name = self.get_sql(scid, tid, trid, data)
+            SQL, name = trigger_utils.get_sql(
+                self.conn, data, tid, trid, self.datlastsysoid,
+                self.blueprint.show_system_objects)
+
             if not isinstance(SQL, (str, unicode)):
                 return SQL
             SQL = SQL.strip('\n').strip(' ')
@@ -842,7 +725,9 @@ class TriggerView(PGChildNodeView):
         data['table'] = self.table
 
         try:
-            sql, name = self.get_sql(scid, tid, trid, data)
+            sql, name = trigger_utils.get_sql(
+                self.conn, data, tid, trid, self.datlastsysoid,
+                self.blueprint.show_system_objects)
             if not isinstance(sql, (str, unicode)):
                 return sql
             sql = sql.strip('\n').strip(' ')
@@ -856,95 +741,6 @@ class TriggerView(PGChildNodeView):
         except Exception as e:
             return internal_server_error(errormsg=str(e))
 
-    def get_trigger_function_schema(self, data):
-        """
-        This function will return trigger function with schema name
-        """
-        # If language is 'edbspl' then trigger function should be
-        # 'Inline EDB-SPL' else we will find the trigger function
-        # with schema name.
-        if data['lanname'] == 'edbspl':
-            data['tfunction'] = 'Inline EDB-SPL'
-        else:
-            SQL = render_template(
-                "/".join([self.template_path, 'get_triggerfunctions.sql']),
-                tgfoid=data['tgfoid'],
-                show_system_objects=self.blueprint.show_system_objects
-            )
-
-            status, result = self.conn.execute_dict(SQL)
-            if not status:
-                return internal_server_error(errormsg=result)
-
-            # Update the trigger function which we have fetched with schema
-            # name
-            if 'rows' in result and len(result['rows']) > 0 and \
-                    'tfunctions' in result['rows'][0]:
-                data['tfunction'] = result['rows'][0]['tfunctions']
-        return data
-
-    def get_sql(self, scid, tid, trid, data):
-        """
-        This function will genrate sql from model data
-        """
-        if trid is not None:
-            SQL = render_template("/".join([self.template_path,
-                                            'properties.sql']),
-                                  tid=tid, trid=trid,
-                                  datlastsysoid=self.datlastsysoid)
-
-            status, res = self.conn.execute_dict(SQL)
-            if not status:
-                return internal_server_error(errormsg=res)
-            if len(res['rows']) == 0:
-                return gone(
-                    gettext("""Could not find the trigger in the table.""")
-                )
-
-            old_data = dict(res['rows'][0])
-
-            # If name is not present in data then
-            # we will fetch it from old data, we also need schema & table name
-            if 'name' not in data:
-                data['name'] = old_data['name']
-
-            self.trigger_name = data['name']
-            self.lanname = old_data['lanname']
-            self.is_trigger_enabled = old_data['is_enable_trigger']
-
-            old_data = self.get_trigger_function_schema(old_data)
-
-            if len(old_data['custom_tgargs']) > 1:
-                # We know that trigger has more than 1 argument, let's join
-                # them
-                old_data['tgargs'] = \
-                    self._format_args(old_data['custom_tgargs'])
-
-            if len(old_data['tgattr']) > 1:
-                columns = ', '.join(old_data['tgattr'].split(' '))
-                old_data['columns'] = self._column_details(tid, columns)
-
-            old_data = self._trigger_definition(old_data)
-
-            SQL = render_template(
-                "/".join([self.template_path, 'update.sql']),
-                data=data, o_data=old_data, conn=self.conn
-            )
-        else:
-            required_args = {
-                'name': 'Name',
-                'tfunction': 'Trigger function'
-            }
-
-            for arg in required_args:
-                if arg not in data:
-                    return gettext('-- definition incomplete')
-
-            # If the request for new object which do not have did
-            SQL = render_template("/".join([self.template_path, 'create.sql']),
-                                  data=data, conn=self.conn)
-        return SQL, data['name'] if 'name' in data else old_data['name']
-
     @check_precondition
     def sql(self, gid, sid, did, scid, tid, trid):
         """
@@ -959,51 +755,9 @@ class TriggerView(PGChildNodeView):
            trid: Trigger ID
         """
 
-        SQL = render_template("/".join([self.template_path,
-                                        'properties.sql']),
-                              tid=tid, trid=trid,
-                              datlastsysoid=self.datlastsysoid)
-
-        status, res = self.conn.execute_dict(SQL)
-        if not status:
-            return internal_server_error(errormsg=res)
-        if len(res['rows']) == 0:
-            return gone(
-                gettext("""Could not find the trigger in the table."""))
-
-        data = dict(res['rows'][0])
-        # Adding parent into data dict, will be using it while creating sql
-        data['schema'] = self.schema
-        data['table'] = self.table
-
-        data = self.get_trigger_function_schema(data)
-
-        if len(data['custom_tgargs']) > 1:
-            # We know that trigger has more than 1 argument, let's join them
-            data['tgargs'] = self._format_args(data['custom_tgargs'])
-
-        if len(data['tgattr']) >= 1:
-            columns = ', '.join(data['tgattr'].split(' '))
-            data['columns'] = self._column_details(tid, columns)
-
-        data = self._trigger_definition(data)
-
-        SQL, name = self.get_sql(scid, tid, None, data)
-
-        sql_header = u"-- Trigger: {0}\n\n-- ".format(data['name'])
-
-        sql_header += render_template("/".join([self.template_path,
-                                                'delete.sql']),
-                                      data=data, conn=self.conn)
-
-        SQL = sql_header + '\n\n' + SQL.strip('\n')
-
-        # If trigger is disbaled then add sql code for the same
-        if data['is_enable_trigger'] != 'O':
-            SQL += '\n\n'
-            SQL += render_template("/".join([self.template_path,
-                                             'enable_disable_trigger.sql']),
-                                   data=data, conn=self.conn)
+        SQL = trigger_utils.get_reverse_engineered_sql(
+            self.conn, self.schema, self.table, tid, trid,
+            self.datlastsysoid, self.blueprint.show_system_objects)
 
         return ajax_response(response=SQL)
 
